package finaljob;
import java.io.*;
import java.net.*;
import java.util.*;

/**
 * <p>Title: Final Job</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: UCONN CSE230</p>
 * @author (sorted alphabetically) Akash Desai, Emmanuel Galema, Haibei Zhang, Subhav Patel
 * @version 1.0
 */

public class DataServer extends Thread
{
  private final int DATA_PORT=10002;
  private Socket data_s;
  private ObjectInputStream data_in;
  private ObjectOutputStream data_out;
  private Vector seeker_v, company_v, employee_v, category_v, description_v, interview_v, cdownloads_v, sdownloadj_v;

  public DataServer(Socket soc, Vector seeker_vec, Vector company_vec, Vector employee_vec, Vector category_vec, Vector description_vec, Vector interview_vec, Vector cdownloads_vec, Vector sdownloadj_vec)
  {
    try
    {
      data_s=soc;
      data_in=new ObjectInputStream(data_s.getInputStream());
      data_out=new ObjectOutputStream(data_s.getOutputStream());
    }
    catch(IOException e)
    {
      System.err.println(e.getMessage());
    }
    seeker_v=seeker_vec;
    company_v=company_vec;
    employee_v=employee_vec;
    category_v=category_vec;
    description_v=description_vec;
    interview_v=interview_vec;
    cdownloads_v=cdownloads_vec;
    sdownloadj_v=sdownloadj_vec;
  }

  public void run()
  {
    Object tempobj;
    Request req;
    try
    {
      while(true)
      {
        tempobj=data_in.readObject();
        if(tempobj instanceof Request)
        {
          req=(Request)tempobj;
          switch(req.getType())
          {
            //processing all types of requests starts here

            //Haibei's handler starts-------------------------------------------
            case 100: //Job Seeker getting personal info
              data_out.writeObject(getSeekerInfo(req.getMsg()));
              break;
            case 101: //Job Seeker searching job description by JID
              data_out.writeObject(searchJobByJID(req.getMsg()));
              break;
            case 102: //Job Seeker searching job description by Company ID
              data_out.writeObject(searchJobByComp(req.getMsg()));
              break;
            case 103: //Job Seeker searching job description by Category
              data_out.writeObject(searchJobByCat(req.getMsg()));
              break;
            case 104: //Job Seeker searching job by detail
              data_out.writeObject(searchJobByDetail(req.getMsg()));
              break;
            case 105: //download a job
              data_out.writeObject(downloadJobDescription(req.getMsg()));
              break;
            case 106:
              data_out.writeObject(seekerRequestInterview(req.getMsg()));
              break;
            //haibei's handler ends---------------------------------------------
            //Akarsh's handler starts-------------------------------------------
            case 200:
            data_out.writeObject(getCompanyInfo(req.getMsg()));
            break;
            case 201:
            data_out.writeObject(searchBySSN(req.getMsg()));///****
            break;
            case 202:
            data_out.writeObject(searchByName(req.getMsg()));///****
            break;
            case 203:
            data_out.writeObject(searchByState(req.getMsg()));
            break;
            case 204:
            data_out.writeObject(searchByResume(req.getMsg()));
            break;
            case 205:
            data_out.writeObject(downloadResume(req.getMsg()));
            break;
            case 206:
            data_out.writeObject(requestInter(req.getMsg()));
            break;
            //Akarsh's handler ends---------------------------------------------
            //Manny's handler starts--------------------------------------------
            case 300://display Job Seeker's Info
            data_out.writeObject(retrieveJobSeekerInfo(req.getMsg()));//added by Manny
            break;
            case 301://display current user's info
            data_out.writeObject(retrieveEmployeeInfo(req.getMsg()));//added by Manny
            break;
            case 302://display Job Description
            data_out.writeObject(retrieveJobDescription(req.getMsg()));//added by Manny
            break;
            //Manny's handler ends----------------------------------------------
            //Subhav's handler starts-------------------------------------------
            case 400: //Manager gettng personnel info
            data_out.writeObject(getManagerInfo(req.getMsg()));
            break;
            case 401: //Employee Inquiry Handler
            data_out.writeObject(getEmployeeInfo(req.getMsg()));
            break;
            case 405: //Add Employee
            data_out.writeObject(addEmployee(req.getMsg()));
            break;
            case 406: //Edit Employee
            data_out.writeObject(editEmployee(req.getMsg()));
            break;
            case 407: //Delete Employee
            data_out.writeObject(deleteEmployee(req.getMsg()));
            break;
            //Subhav's handler ends---------------------------------------------

            //processing all types of requests ends here
            default:
              data_out.writeObject("Server Error: No handler found for this request");
          }
        }
        data_out.flush();
      }
    }
    catch(IOException e)
    {
      System.err.println(e.getMessage());
    }
    catch(ClassNotFoundException e)
    {
      System.err.println(e.getMessage());
    }
  }

//haibei's handler starts here-----------------------------------------------------
  //100 request handler
  private Seeker getSeekerInfo(String ssn)
  {
    for(int i=0;i<seeker_v.size();i++)
    {
      if(((Seeker)seeker_v.elementAt(i)).getSSN().equalsIgnoreCase(ssn))
        return (Seeker)seeker_v.elementAt(i);
    }
    return null;
  }

  //101 request handler
  private Vector searchJobByJID(String keyword)
  {
    Vector tempv=new Vector();
    for(int i=0;i<description_v.size();i++)
    {
      if(((Description)description_v.elementAt(i)).getJid().equalsIgnoreCase(keyword))
        tempv.add(((Description)description_v.elementAt(i)).getJid());
    }
    return tempv;
  }

  //102 request handler
  private Vector searchJobByComp(String keyword)
  {
    Vector tempv=new Vector();
    for(int i=0;i<description_v.size();i++)
    {
      if(((Description)description_v.elementAt(i)).getCid().equalsIgnoreCase(keyword))
        tempv.add(((Description)description_v.elementAt(i)).getJid());
    }
    return tempv;
  }

  //103 request handler
  private Vector searchJobByCat(String keyword)
  {
    Vector tempv=new Vector();
    for(int i=0;i<description_v.size();i++)
    {
      if(((Description)description_v.elementAt(i)).getJcid().equalsIgnoreCase(keyword))
        tempv.add(((Description)description_v.elementAt(i)).getJid());
    }
    return tempv;
  }

  //104 request handler
  private Vector searchJobByDetail(String keyword)
  {
    Vector tempv=new Vector();
    for(int i=0;i<description_v.size();i++)
    {
      for(int j=0;j<((Description)description_v.elementAt(i)).getDoc().length();j++)
        if(((Description)description_v.elementAt(i)).getDoc().toUpperCase().startsWith(keyword.toUpperCase().trim(), j))
          tempv.add(((Description)description_v.elementAt(i)).getJid());
    }
    return tempv;
  }

  //105 download job description
  private String downloadJobDescription(String j)
  {
    for(int i=0;i<description_v.size();i++)
    {
      if(((Description)description_v.elementAt(i)).getJid().equalsIgnoreCase(j))
      {
        ((Description)description_v.elementAt(i)).incrementBeDownloaded();
        return ((Description)description_v.elementAt(i)).getDoc()+"\n\nThis document has been downloaded "+((Description)description_v.elementAt(i)).getBeDownloaded()+" times.";
      }

    }
    return "No document found";
  }

  //106 seeker request interview
  private String seekerRequestInterview(String seekerID)
  {
    for(int i=0;i<description_v.size();i++)
    {
      if(((Seeker)seeker_v.elementAt(i)).getSSN().equalsIgnoreCase(seekerID))
      {
        ((Seeker)seeker_v.elementAt(i)).setBalance(((Seeker)seeker_v.elementAt(i)).getBalance()-1);
        return "Interview requested, your balance is now $"+((Seeker)seeker_v.elementAt(i)).getBalance();
      }

    }
    return "No document found";
  }

  /*define other functions, i.e. addSeeker(String SSN, String name, String Address ......)*/

  //haibei's handler ends here-------------------------------------------------------

  //Akarsh's request handler starts here---------------------------------------------

 private String getCompanyInfo(String cid)
  {
    for(int i=0;i<company_v.size();i++)
    {
      if(((Company)company_v.elementAt(i)).getCID().equalsIgnoreCase(cid))
        return ("CID: "+((Company)company_v.elementAt(i)).getCID()+"\nCompany: "+((Company)company_v.elementAt(i)).getname()+"\nAdress: \n"+((Company)company_v.elementAt(i)).getStreet()+" "+((Company)company_v.elementAt(i)).getCity()+"\n "+((Company)company_v.elementAt(i)).getState()+"-"+((Company)company_v.elementAt(i)).getZip()+"\nTelePhone:\n "+((Company)company_v.elementAt(i)).getTel()+"\nEmai: \n"+((Company)company_v.elementAt(i)).getEmail()+"\nYour Job Add.IDS:\n"+((Description)description_v.elementAt(i)).getJid());
    }
    return null;
  }
 private Vector searchBySSN(String k)
  {
    Vector tempcv=new Vector();
    for(int i=0;i<seeker_v.size();i++)
    {
      if(((Seeker)seeker_v.elementAt(i)).getSSN().equalsIgnoreCase(k))
        tempcv.add(((Seeker)seeker_v.elementAt(i)).getLname());
    }

    return tempcv;
  }

  private Vector searchByName(String k)
   {
     Vector tempcv=new Vector();
     for(int i=0;i<seeker_v.size();i++)
     {
       if(((Seeker)seeker_v.elementAt(i)).getFname().toUpperCase().startsWith(k.trim().toUpperCase())||((Seeker)seeker_v.elementAt(i)).getLname().toUpperCase().startsWith(k.trim().toUpperCase()))
         tempcv.add(((Seeker)seeker_v.elementAt(i)).getLname());
     }

     return tempcv;
  }

  private Vector searchByState(String word)
  {
    Vector temdv=new Vector();
    for(int i=0;i<seeker_v.size();i++)
    {
      if(((Seeker)seeker_v.elementAt(i)).getState().equalsIgnoreCase(word))
        temdv.add(((Seeker)seeker_v.elementAt(i)).getLname());
    }

    return temdv;
  }

   private Vector searchByResume(String keyword)
   {
     Vector tempv=new Vector();
     for(int i=0;i<seeker_v.size();i++)
     {
       for(int j=0;j<((Seeker)seeker_v.elementAt(i)).getDoc().length();j++)
         if(((Seeker)seeker_v.elementAt(i)).getDoc().toUpperCase().startsWith(keyword.toUpperCase().trim(), j))
           tempv.add(((Seeker)seeker_v.elementAt(i)).getSSN());
     }
    return tempv;
  }

  private String downloadResume(String word)
  {

    for(int i=0;i<seeker_v.size();i++)
    {
      if(((Seeker)seeker_v.elementAt(i)).getLname().equalsIgnoreCase(word))
      {
        ((Seeker)seeker_v.elementAt(i)).incrementBeDownloaded();
      return(((Seeker)seeker_v.elementAt(i)).getDoc())+"\n\nThis resume has been downloaded "+((Seeker)seeker_v.elementAt(i)).getBeDownloaded()+" times.";
    }
    }
    return null;

  }
   private String requestInter(String word)
  {

    for(int i=0;i<seeker_v.size();i++)
    {
      if(((Seeker)seeker_v.elementAt(i)).getLname().equalsIgnoreCase(word))
      {

      return("\nFirst Name:"+((Seeker)seeker_v.elementAt(i)).getFname()+"\nLast Name:"+((Seeker)seeker_v.elementAt(i)).getLname()+"\nEmail Adress:"+((Seeker)seeker_v.elementAt(i)).getEmail()+"\nTelePhone No: "+((Seeker)seeker_v.elementAt(i)).getTel());//+"\nViewed: "+((Seeker)seeker_v.elementAt(i)).getBeDownloaded());

         //((Company)company_v.elementAt(i)).getDownload();  //***
    }
     }
    return null;
   }

   //Ararsh's handler ends here-----------------------------------------------------------

   //Manny's handler starts here----------------------------------------------------------
   //300 request handler															modified by Manny
private Seeker retrieveJobSeekerInfo(String ssn)
{
  for(int i=0;i<seeker_v.size();i++)
  {
    if(((Seeker)seeker_v.elementAt(i)).getSSN().equalsIgnoreCase(ssn))
      return (Seeker)seeker_v.elementAt(i);
  }
  return null;
}

//301 request handler															modified by Manny
private Employee retrieveEmployeeInfo(String ssn)
{
  for(int i=0;i<employee_v.size();i++)
  {
    if(((Employee)employee_v.elementAt(i)).getSSN().equalsIgnoreCase(ssn))
      return (Employee)employee_v.elementAt(i);
  }
  return null;
}

//302 request handler															modified by Manny
private Description retrieveJobDescription(String jid)
{
  for(int i=0;i<description_v.size();i++)
  {
    if(((Description)description_v.elementAt(i)).getJid().equalsIgnoreCase(jid))
      return (Description)description_v.elementAt(i);
  }
  return null;
}
//Manny's handler ends here-------------------------------------------------------------

//Subhav's handler starts here---------------------------------------------------
// 400 Manager Get Info handler
private Employee getManagerInfo(String ssn)
{
for(int i=0;i<employee_v.size();i++)
{
if(((Employee)employee_v.elementAt(i)).getSSN().equalsIgnoreCase(ssn))
  return (Employee)employee_v.elementAt(i);
}
return null;
}

// 401 Employee Inquiry handler
private Employee getEmployeeInfo(String ssn)
{
for(int i=0;i<employee_v.size();i++)
{
if(((Employee)employee_v.elementAt(i)).getSSN().equalsIgnoreCase(ssn))
  return (Employee)employee_v.elementAt(i);
}
return null;
}

// 405 Add new employee
//private Vector addEmployee(String ssn, boolean isManager, String fname, String lname, String street, String city,String stat, String zip, String tel, String email, String startDate, String rate, String manager_ssn)
private Vector addEmployee(String info)
{
return null;
}

// 406 Edit employee
private Vector editEmployee(String ssn)
{
Vector employee_v=new Vector();
for(int i=0;i<employee_v.size();i++)
{
if(((Employee)employee_v.elementAt(i)).getSSN().equalsIgnoreCase(ssn))
  employee_v.add(((Employee)employee_v.elementAt(i)).getSSN());
}
return employee_v;
}
// 407 Delete employee
private Vector deleteEmployee(String ssn)
{
Vector employee_v=new Vector();
for(int i=0;i<employee_v.size();i++)
{
if(((Employee)employee_v.elementAt(i)).getSSN().equalsIgnoreCase(ssn))
  employee_v.add(((Employee)employee_v.elementAt(i)).getSSN());
}
return employee_v;
}
//Subhav's handler ends here----------------------------------------------------

}