package finaljob;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.util.*;


/**
 * <p>Title: Final Job</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: UCONN CSE230</p>
 * @author (sorted alphabetically) Akash Desai, Emmanuel Galema, Haibei Zhang, Subhav Patel
 * @version 1.0
 */

public class Frame1 extends JFrame
{
  private JPanel contentPane;
  private JMenuBar jMenuBar1 = new JMenuBar();
  private JMenu jMenuFile = new JMenu();
  private JMenuItem jMenuFileExit = new JMenuItem();
  private JMenu jMenuHelp = new JMenu();
  private JMenuItem jMenuHelpAbout = new JMenuItem();
  private JToolBar jToolBar = new JToolBar();
  private JButton loadbutton = new JButton();
  private JButton savebutton = new JButton();
  private JButton jButton3 = new JButton();
  private ImageIcon image1;
  private ImageIcon image2;
  private ImageIcon image3;
  private JLabel statusBar = new JLabel();
  private BorderLayout borderLayout1 = new BorderLayout();

  //Properties needed for networking
  private final int AUTHORIZATION_PORT=10001;
  private final int DATA_PORT=10002;
  private ServerSocket auth_ss;
  private ServerSocket data_ss;
  private Socket auth_s;
  private Socket data_s;
  private BufferedReader auth_in;
  private PrintWriter auth_out;

  //Local properties
  private String login_info;
  private String listitem;
  private InetAddress clientaddress;
  private Vector onlinelist_v=new Vector();

  //Properties needed for data storage
  private Vector seeker_v, company_v, employee_v, description_v, category_v, interview_v, sdownloadj_v, cdownloads_v;
  private ObjectInputStream ifstream;
  private ObjectOutputStream ofstream;

  //Construct the frame
  public Frame1()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

    //Testing data loading starts
    //Fill the vector with testing data for testing only, real application should read data from file
    seeker_v=new Vector();
    employee_v=new Vector();
    company_v=new Vector();
    description_v=new Vector();
    category_v=new Vector();
    interview_v=new Vector();
    sdownloadj_v=new Vector();
    cdownloads_v=new Vector();

/*    seeker_v.add(new Seeker("00001", "Haibei", "Zhang", "Jorgensen Rd.", "Storrs", "CT", "06269", "86042772768", "haibei.zhang@uconn.edu"));
    seeker_v.add(new Seeker("00002","Emannuel","Galema","Mansfield Rd.","Storrs","CT","06269","n/a","Elgalema@aol.com"));
   employee_v.add(new Employee("00003",false,"Akash","Desai","Glenbrook Rd.","Storrs","CT","06269","n/a","indir741@hotmail.com"));
   employee_v.add(new Employee("00004",true,"Manish","Sarkar","North Eagleville","Storrs","CT","06269","n/a","manish@engr.uconn.edu"));
   company_v.add(new Company("c00001","Subhav Inc.","Hillside Rd.","Storrs","CT","06269","n/a","subhav111@hotmail.com"));
   description_v.add(new Description("j00001", "c00001", "CEO", "jc001", "We are hunting for a CEO! \nrequirement: everyone can apply\nSend your resume to UTEB 175"));
*/    //Testing data loading ends

    Thread auth_server=new Thread()
    {
      public void run()
      {
        try
        {
          auth_ss=new ServerSocket(AUTHORIZATION_PORT);
          while(true)
          {
            auth_s=auth_ss.accept();
            auth_in=new BufferedReader(new InputStreamReader(auth_s.getInputStream()));
            auth_out=new PrintWriter(auth_s.getOutputStream(), true /*auto flush*/);
            clientaddress=auth_s.getInetAddress();

              String login_request=auth_in.readLine();
              statusBar.setText("USER "+login_request+" attempting to log in");
              switch(authorizeID(login_request))
              {
                case 'm':
                  auth_out.println("Manager");
                  listitem="Manager "+login_request+" logged in at "+(new Date()).toString();
                  break;

                case 'r':
                  auth_out.println("Representative");
                  listitem="Representative "+login_request+" logged in at "+(new Date()).toString();
                  break;

                case 's':
                  auth_out.println("Job Seeker");
                  listitem="Job seeker "+login_request+" logged in at "+(new Date()).toString();
                  break;

                case 'c':
                  auth_out.println("Company");
                  listitem="Company "+login_request+" logged in at "+(new Date()).toString();
                  break;

                case 'u':
                  auth_out.println("Not Logged In");
                  listitem="Unknown user "+login_request+" failed to login at "+(new Date()).toString();
                  break;
              }

            onlinelist_v.add(listitem);
            onlineList.setListData(onlinelist_v);
            onlineList.repaint();



          }
        }
        catch(IOException e1)
        {
          System.err.println("Auth Server Error: "+e1.getMessage());
        }
      }
    };


    Thread data_server=new Thread()
    {
      public void run()
      {
        try
        {
          data_ss=new ServerSocket(DATA_PORT);
          while(true)
          {
            data_s=data_ss.accept();
            (new DataServer(data_s, seeker_v, company_v, employee_v, category_v, description_v, interview_v, cdownloads_v, sdownloadj_v)).start();
          }
        }
        catch(IOException e2)
        {
          System.err.println("Data Server Error:"+e2.getMessage());
        }
      }
    };
    data_server.start();auth_server.start();

  }
  //Component initialization
  private void jbInit() throws Exception  {
    image1 = new ImageIcon(finaljob.Frame1.class.getResource("openFile.gif"));
    image2 = new ImageIcon(finaljob.Frame1.class.getResource("closeFile.gif"));
    image3 = new ImageIcon(finaljob.Frame1.class.getResource("help.gif"));
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Frame1.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(754, 576));
    this.setTitle("Final Job: Server");
    statusBar.setBorder(BorderFactory.createLoweredBevelBorder());
    statusBar.setText(" ");
    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuFileExit_actionPerformed(e);
      }
    });
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuHelpAbout_actionPerformed(e);
      }
    });
    loadbutton.setIcon(image1);
    loadbutton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        loadbutton_actionPerformed(e);
      }
    });
    loadbutton.setToolTipText("Load data from \"finaljob_data.dat\"");
    savebutton.setIcon(image2);
    savebutton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        savebutton_actionPerformed(e);
      }
    });
    savebutton.setToolTipText("Save Data to \"finaljob_data.dat\"");
    jButton3.setIcon(image3);
    jButton3.setToolTipText("Help");
    jPanel1.setLayout(borderLayout2);
    jLabel1.setText("                                ");
    jLabel2.setText("                                ");
    jLabel3.setFont(new java.awt.Font("Dialog", 1, 16));
    jLabel3.setForeground(Color.blue);
    jLabel3.setText("                                Current Logged in Users:");
    jToolBar.add(loadbutton);
    jToolBar.add(savebutton);
    jToolBar.add(jButton3);
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    this.setJMenuBar(jMenuBar1);
    contentPane.add(jToolBar, BorderLayout.NORTH);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    contentPane.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jLabel1, BorderLayout.WEST);
    jPanel1.add(jLabel2,  BorderLayout.EAST);
    jPanel1.add(jLabel3, BorderLayout.NORTH);
    jPanel1.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(onlineList, null);
  }
  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
  //Help | About action performed
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    Frame1_AboutBox dlg = new Frame1_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  private char authorizeID(String id)
  {
    int i;
    for(i=0;i<employee_v.size();i++)
      if(((Employee)employee_v.elementAt(i)).getSSN().equalsIgnoreCase(id))
      {
        if(((Employee)employee_v.elementAt(i)).getIsManager())
          return 'm';
        else
          return 'r';
      }

    for(i=0;i<seeker_v.size();i++)
      if(((Seeker)seeker_v.elementAt(i)).getSSN().equalsIgnoreCase(id))
        return 's';

    for(i=0;i<company_v.size();i++)
      if(((Company)company_v.elementAt(i)).getCID().equalsIgnoreCase(id))
        return 'c';

    return 'u'; //Unauthorized user
  }
  private JPanel jPanel1 = new JPanel();
  private BorderLayout borderLayout2 = new BorderLayout();
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JLabel jLabel3 = new JLabel();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JList onlineList = new JList(onlinelist_v);


  void savebutton_actionPerformed(ActionEvent e)
  {
    save();
  }

  private void save()
  {
    try
    {
      ofstream=new ObjectOutputStream(new FileOutputStream("finaljob_data.dat"));
      ofstream.writeObject(seeker_v);
      ofstream.writeObject(employee_v);
      ofstream.writeObject(company_v);
      ofstream.writeObject(description_v);
      ofstream.writeObject(category_v);
      ofstream.writeObject(interview_v);
      ofstream.writeObject(sdownloadj_v);
      ofstream.writeObject(cdownloads_v);
      ofstream.flush();
      ofstream.close();
      statusBar.setText("Data saved in finaljob_data.dat");
    }
    catch(IOException fo_e)
    {
      System.err.println(fo_e.getMessage());
    }
  }

  private void load()
  {
    try
    {
      ifstream=new ObjectInputStream(new FileInputStream("finaljob_data.dat"));
      seeker_v=(Vector)ifstream.readObject();
      employee_v=(Vector)ifstream.readObject();
      company_v=(Vector)ifstream.readObject();
      description_v=(Vector)ifstream.readObject();
      category_v=(Vector)ifstream.readObject();
      interview_v=(Vector)ifstream.readObject();
      sdownloadj_v=(Vector)ifstream.readObject();
      cdownloads_v=(Vector)ifstream.readObject();
      ifstream.close();
      statusBar.setText("Data loaded from finaljob_data.dat");

    }
    catch(IOException fi_e)
    {
      System.err.println(fi_e.getMessage());
    }
    catch(ClassNotFoundException fi_e2)
    {
      System.err.println(fi_e2.getMessage());
    }
  }

  void loadbutton_actionPerformed(ActionEvent e)
  {
    load();
  }
}