package finaljob;
import java.io.*;
import java.net.*;
import java.util.*;

/**
 * <p>Title: Final Job</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: UCONN CSE230</p>
 * @author (sorted alphabetically) Akash Desai, Emmanuel Galema, Haibei Zhang, Subhav Patel
 * @version 1.0
 */

public class DataServer extends Thread
{
  private final int DATA_PORT=10002;
  private Socket data_s;
  private ObjectInputStream data_in;
  private ObjectOutputStream data_out;
  private Vector seeker_v, company_v, employee_v, category_v, description_v, interview_v, cdownloads_v, sdownloadj_v;

  public DataServer(Socket soc, Vector seeker_vec, Vector company_vec, Vector employee_vec, Vector category_vec, Vector description_vec, Vector interview_vec, Vector cdownloads_vec, Vector sdownloadj_vec)
  {
    try
    {
      data_s=soc;
      data_in=new ObjectInputStream(data_s.getInputStream());
      data_out=new ObjectOutputStream(data_s.getOutputStream());
    }
    catch(IOException e)
    {
      System.err.println(e.getMessage());
    }
    seeker_v=seeker_vec;
    company_v=company_vec;
    employee_v=employee_vec;
    category_v=category_vec;
    description_v=description_vec;
    interview_v=interview_vec;
    cdownloads_v=cdownloads_vec;
    sdownloadj_v=sdownloadj_vec;
  }

  public void run()
  {
    Object tempobj;
    Request req;
    try
    {
      while(true)
      {
        tempobj=data_in.readObject();
        if(tempobj instanceof Request)
        {
          req=(Request)tempobj;
          switch(req.getType())
          {
            //processing all types of requests starts here


            case 100: //Job Seeker getting personal info
              data_out.writeObject(getSeekerInfo(req.getMsg()));
            case 101: //Job Seeker searching job description by JID
              data_out.writeObject(searchByJID(req.getMsg()));
            case 105: //download a job
              data_out.writeObject(downloadJobDescription(req.getMsg()));



            //processing all types of requests ends here
            default:
              data_out.writeObject("Server Error: No handler found for this request");
          }
        }
        data_out.flush();
      }
    }
    catch(IOException e)
    {
      System.err.println(e.getMessage());
    }
    catch(ClassNotFoundException e)
    {
      System.err.println(e.getMessage());
    }
  }

  //100 request handler
  private Seeker getSeekerInfo(String ssn)
  {
    for(int i=0;i<seeker_v.size();i++)
    {
      if(((Seeker)seeker_v.elementAt(i)).getSSN().equalsIgnoreCase(ssn))
        return (Seeker)seeker_v.elementAt(i);
    }
    return null;
  }

  //101 request handler
  private Vector searchByJID(String keyword)
  {
    Vector tempv=new Vector();
    for(int i=0;i<description_v.size();i++)
    {
      if(((Description)description_v.elementAt(i)).getJid().equalsIgnoreCase(keyword))
        tempv.add(((Description)description_v.elementAt(i)).getJid());
    }
    return tempv;
  }

  //105 download job description
  private String downloadJobDescription(String j)
  {
    for(int i=0;i<description_v.size();i++)
    {
      if(((Description)description_v.elementAt(i)).getJid().equalsIgnoreCase(j))
      {
        ((Description)description_v.elementAt(i)).incrementBeDownloaded();
        return ((Description)description_v.elementAt(i)).getDoc();
      }

    }
    return "No document found";
  }

  /*define other functions, i.e. addSeeker(String SSN, String name, String Address ......)*/
}