package finaljob;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.util.*;


/**
 * <p>Title: Final Job</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: UCONN CSE230</p>
 * @author (sorted alphabetically) Akash Desai, Emmanuel Galema, Haibei Zhang, Subhav Patel
 * @version 1.0
 */

public class Frame1 extends JFrame
{
  private JPanel contentPane;
  private JMenuBar jMenuBar1 = new JMenuBar();
  private JMenu jMenuFile = new JMenu();
  private JMenuItem jMenuFileExit = new JMenuItem();
  private JMenu jMenuHelp = new JMenu();
  private JMenuItem jMenuHelpAbout = new JMenuItem();
  private JToolBar jToolBar = new JToolBar();
  private JButton jButton1 = new JButton();
  private JButton jButton2 = new JButton();
  private JButton jButton3 = new JButton();
  private ImageIcon image1;
  private ImageIcon image2;
  private ImageIcon image3;
  private JLabel statusBar = new JLabel();
  private BorderLayout borderLayout1 = new BorderLayout();

  private final int AUTHORIZATION_PORT=10001;
  private final int DATA_PORT=10002;
  private ServerSocket auth_ss;
  private ServerSocket data_ss;
  private Socket auth_s;
  private Socket data_s;
  private BufferedReader auth_in;
  private PrintWriter auth_out;

  private String login_info;
  private InetAddress clientaddress;

  private Vector seeker_v, company_v, employee_v, description_v, category_v, interview_v, sdownloadj_v, cdownloads_v;


  //Construct the frame
  public Frame1()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

    //Testing data loading starts
    //Fill the vector with testing data for testing only, real application should read data from file
    seeker_v=new Vector();
    employee_v=new Vector();
    company_v=new Vector();
    description_v=new Vector();
    category_v=new Vector();
    interview_v=new Vector();
    sdownloadj_v=new Vector();
    cdownloads_v=new Vector();

    seeker_v.add(new Seeker("00001", "Haibei", "Zhang", "Jorgensen Rd.", "Storrs", "CT", "06269", "86042772768", "haibei.zhang@uconn.edu"));
    seeker_v.add(new Seeker("00002","Emannuel","Galema","Mansfield Rd.","Storrs","CT","06269","n/a","Elgalema@aol.com"));
    employee_v.add(new Employee("00003",false,"Akash","Desai","Glenbrook Rd.","Storrs","CT","06269","n/a","indir741@hotmail.com"));
    employee_v.add(new Employee("00004",true,"Manish","Sarkar","North Eagleville","Storrs","CT","06269","n/a","manish@engr.uconn.edu"));
    company_v.add(new Company("c00001","Subhav Inc.","Hillside Rd.","Storrs","CT","06269","n/a","subhav111@hotmail.com"));
    description_v.add(new Description("j00001", "c00001", "CEO", "jc001", "We are hunting for a CEO! \nrequirement: everyone can apply\nSend your resume to UTEB 175"));
    //Testing data loading ends

    Thread auth_server=new Thread()
    {
      public void run()
      {
        try
        {
          auth_ss=new ServerSocket(AUTHORIZATION_PORT);
          while(true)
          {
            auth_s=auth_ss.accept();
            auth_in=new BufferedReader(new InputStreamReader(auth_s.getInputStream()));
            auth_out=new PrintWriter(auth_s.getOutputStream(), true /*auto flush*/);
            clientaddress=auth_s.getInetAddress();
            if(auth_in.ready())
            {
              String login_request=auth_in.readLine();
              statusBar.setText("USER "+login_request+" attempting to log in");
              switch(authorizeID(login_request))
              {
                case 'm':
                  auth_out.println("Manager");
                  break;

                case 'r':
                  auth_out.println("Representative");
                  break;

                case 's':
                  auth_out.println("Job Seeker");
                  break;

                case 'c':
                  auth_out.println("Company");
                  break;

                case 'u':
                  auth_out.println("Not Logged In");
                  break;
              }
            }
          }
        }
        catch(IOException e1)
        {
          System.err.println("Auth Server Error: "+e1.getMessage());
        }
      }
    };


    Thread data_server=new Thread()
    {
      public void run()
      {
        try
        {
          data_ss=new ServerSocket(DATA_PORT);
          while(true)
          {
            data_s=data_ss.accept();
            (new DataServer(data_s, seeker_v, company_v, employee_v, category_v, description_v, interview_v, cdownloads_v, sdownloadj_v)).start();
          }
        }
        catch(IOException e2)
        {
          System.err.println("Data Server Error:"+e2.getMessage());
        }
      }
    };
    data_server.start();auth_server.start();

  }
  //Component initialization
  private void jbInit() throws Exception  {
    image1 = new ImageIcon(finaljob.Frame1.class.getResource("openFile.gif"));
    image2 = new ImageIcon(finaljob.Frame1.class.getResource("closeFile.gif"));
    image3 = new ImageIcon(finaljob.Frame1.class.getResource("help.gif"));
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Frame1.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(754, 576));
    this.setTitle("Final Job: Server");
    statusBar.setBorder(BorderFactory.createLoweredBevelBorder());
    statusBar.setText(" ");
    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuFileExit_actionPerformed(e);
      }
    });
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuHelpAbout_actionPerformed(e);
      }
    });
    jButton1.setIcon(image1);
    jButton1.setToolTipText("Open File");
    jButton2.setIcon(image2);
    jButton2.setToolTipText("Close File");
    jButton3.setIcon(image3);
    jButton3.setToolTipText("Help");
    jToolBar.add(jButton1);
    jToolBar.add(jButton2);
    jToolBar.add(jButton3);
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    this.setJMenuBar(jMenuBar1);
    contentPane.add(jToolBar, BorderLayout.NORTH);
    contentPane.add(statusBar, BorderLayout.SOUTH);
  }
  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
  //Help | About action performed
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    Frame1_AboutBox dlg = new Frame1_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  private char authorizeID(String id)
  {
    int i;
    for(i=0;i<employee_v.size();i++)
      if(((Employee)employee_v.elementAt(i)).getSSN().equalsIgnoreCase(id))
      {
        if(((Employee)employee_v.elementAt(i)).getIsManager())
          return 'm';
        else
          return 'r';
      }

    for(i=0;i<seeker_v.size();i++)
      if(((Seeker)seeker_v.elementAt(i)).getSSN().equalsIgnoreCase(id))
        return 's';

    for(i=0;i<company_v.size();i++)
      if(((Company)company_v.elementAt(i)).getCID().equalsIgnoreCase(id))
        return 'c';

    return 'u'; //Unauthorized user
  }
}